searchData={"items":[{"type":"module","title":"LiveElements","doc":"Documentation for `LiveElements`.","ref":"LiveElements.html"},{"type":"function","title":"LiveElements.hello/0","doc":"Hello world.","ref":"LiveElements.html#hello/0"},{"type":"function","title":"Examples - LiveElements.hello/0","doc":"iex> LiveElements.hello()\n    :world","ref":"LiveElements.html#hello/0-examples"},{"type":"module","title":"LiveElements.CustomElementsHelpers","doc":"","ref":"LiveElements.CustomElementsHelpers.html"},{"type":"macro","title":"LiveElements.CustomElementsHelpers.custom_element/2","doc":"","ref":"LiveElements.CustomElementsHelpers.html#custom_element/2"},{"type":"function","title":"LiveElements.CustomElementsHelpers.custom_element_tag/3","doc":"","ref":"LiveElements.CustomElementsHelpers.html#custom_element_tag/3"},{"type":"function","title":"LiveElements.CustomElementsHelpers.custom_elements/0","doc":"","ref":"LiveElements.CustomElementsHelpers.html#custom_elements/0"},{"type":"function","title":"LiveElements.CustomElementsHelpers.custom_event_hook/0","doc":"","ref":"LiveElements.CustomElementsHelpers.html#custom_event_hook/0"},{"type":"function","title":"LiveElements.CustomElementsHelpers.find_custom_elements/1","doc":"","ref":"LiveElements.CustomElementsHelpers.html#find_custom_elements/1"},{"type":"function","title":"LiveElements.CustomElementsHelpers.function_name/1","doc":"","ref":"LiveElements.CustomElementsHelpers.html#function_name/1"},{"type":"function","title":"LiveElements.CustomElementsHelpers.serialize/1","doc":"","ref":"LiveElements.CustomElementsHelpers.html#serialize/1"},{"type":"function","title":"LiveElements.CustomElementsHelpers.serialize_value/1","doc":"","ref":"LiveElements.CustomElementsHelpers.html#serialize_value/1"},{"type":"function","title":"LiveElements.CustomElementsHelpers.tagify/1","doc":"","ref":"LiveElements.CustomElementsHelpers.html#tagify/1"},{"type":"extras","title":"LiveElements","doc":"# LiveElements","ref":"readme.html"},{"type":"extras","title":"Goals - LiveElements","doc":"The goal of LiveElements is to improve the ergonomics of integrating custom HTML elements with [Phoenix LiveView](https://hexdocs.pm/phoenix_live_view).","ref":"readme.html#goals"},{"type":"extras","title":"Non-goals - LiveElements","doc":"This project assumes\nyou are using custom elements on a page served by phoenix. If you are building custom elements \nthat need to talk to a phoenix app but live on a page not served by phoenix (on a statically generated site for example), you may want to check out [LiveState](https://hexdocs.pm/live_state) instead.","ref":"readme.html#non-goals"},{"type":"extras","title":"Description - LiveElements","doc":"We accomplish our goal by creating helper functions to make \nworking with custom elements just as easy as any other LiveView functional component.\n\nFor example, let's say you have a ` ` custom element that has an attribute \nthat takes a list of todos, and emits an `add_todo` Custom Event. LiveElements will \ngenerate a helper function (details below) which will wrap the custom element like\nso:\n\n```heex\n<.todo_list todos={@todos}></.todo_list>\n```\n\nSerialization of todos to json happens automatically. In your live view you handle the `add_todo` event just like any other live view event:\n\n```elixir\n  def handle_event(\"add_todo\", %{\"todo\" => todo}, %{assigns: %{todos: todos}} = socket) do\n    {:noreply, socket |> assign(todos: todos ++ [todo])}\n  end\n```","ref":"readme.html#description"},{"type":"extras","title":"Installation - LiveElements","doc":"#","ref":"readme.html#installation"},{"type":"extras","title":"Install hex package - LiveElements","doc":"If [available in Hex](https://hex.pm/docs/publish), the package can be installed\nby adding `live_elements` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:live_elements, \"~> 0.2.1\"}\n  ]\nend\n```\n\n#","ref":"readme.html#install-hex-package"},{"type":"extras","title":"Install Custom Events hook - LiveElements","doc":"Presuming your custom element emits custom events you want to handle in live view, you'll need to install the `phoenix-custom-event-hook` npm package and add the hook \nto the live socket.\n\nTo install (from project dir):\n\n```\nnpm install --prefix assets phoenix-custom-event-hook\n```\n\nThen, in `app.js` (or wherever you set up your live socket):\n\n```js\nimport PhoenixCustomEventHook from 'phoenix-custom-event-hook';\n\nlet csrfToken = document.querySelector(\"meta[name='csrf-token']\").getAttribute(\"content\")\nlet liveSocket = new LiveSocket(\"/live\", Socket, {params: {_csrf_token: csrfToken}, hooks: {PhoenixCustomEventHook}})\n```\n\n# Usage\n\nIn the LiveViews where you want to call custom element helper functions do:\n\n```\nuse LiveElements.CustomElementsHelpers\n```\n\nThis will add helper functions for any custom elements found in your manifest file, if\nyou have one configured, as well as importing the `custom_element` macro.","ref":"readme.html#install-custom-events-hook"},{"type":"extras","title":"Producing helper functions from a custom elements manifest file - LiveElements","doc":"LiveElements can consume a [custom elements manifest file](https://github.com/webcomponents/custom-elements-manifest) to produce helper functions\nat compile time. To do so, in your config:\n\n```elixir\nconfig :live_elements, \n  custom_elements_manifest: Path.expand(\"../assets/custom-elements.json\", __DIR__)\n```\n\nTo produce a manifest file automatically from your custom element source code, you might want to check out the [custom element analyzer](https://custom-elements-manifest.open-wc.org/analyzer/getting-started/) from open-wc.org.","ref":"readme.html#producing-helper-functions-from-a-custom-elements-manifest-file"},{"type":"extras","title":"Using the `custom_element` macro - LiveElements","doc":"If you are using a library that does not have a manifest, or don't wish to use one, you can \nalso use the `custom_element` macro like so:\n\n```elixir\n  custom_element :bx_data_table, events: [\"bx-table-header-cell-sort\"]\n```\n\nThis would then allow you to call `<.bx_data_table>` in your live view and `handle_event(\"bx-table-header-cell-sort\", ...)` to respond to events.\n\n# Example\n\nThe [live_elements_testbed](https://github.com/launchscout/live_elements_testbed) contains an \nexample phoenix liveview app demonstrating all of the features of live_elements, as well as\nintegration tests for the live_elements project.","ref":"readme.html#using-the-custom_element-macro"}],"content_type":"text/markdown"}